
CON
  _clkmode = xtal1 + pll16x        'Standard clock mode * crystal frequency = 80 MHz
  _xinfreq = 5_000_000                  
  RXp              = 0             
  BaudM         = 9600            
 

VAR
  byte Startbyte, PinState, cwvL, cwvH, cwwL, cwwH, cwxL, cwxH, cwyL, cwyH, cwzL, cwzH 
  byte  Buffer [12], rxByte
  long  sin,  inverted, bitTime, bitTime2, rxOkay
  

OBJ
  Timing        : "Timing.spin"
  VGA           : "VGA_Text"

PUB   Initialize
  VGA.start(16)                                         ' Start the Debug on VGA screen
  VGA.out($01)
  init (RXp,BaudM)                                  ' Start serial driver
  Timing.Pause (200)
  Main

PUB Main
  repeat
    outa[RXp]~ 
    Timing.Pause (10)                         '10ms
    Recieve
    Timing.Pause (3000)                       '3 s interval
    

PUB Recieve | Index
  repeat until rxbyte == $80
    rx
    Buffer [0] := rxByte
  repeat Index from 1 to 11                  
    rx
    Buffer [index] := rxByte
  calculate
  Display_Values
   
PUB init(rxPin, Baud): Okay
  'finalize                                              ' clean-up if restart
  rxOkay := rxPin > -1                                  ' receiving?
  sin := rxPin & $1F                                    ' set rx pin
  inverted := baud > 0                                  ' set inverted flag
  bitTime := clkfreq / ((||baud))
  return rxOkay 

PUB finalize
                                      '   float tx pin
  rxOkay :=  false
     
PUB rx |  t
{{ Receive a byte; blocks caller until byte received. }}
 if rxOkay
   dira[sin]~                                           ' make rx pin an input
   waitpeq(inverted & |< sin, |< sin, 0)                ' wait for start bit
   t := cnt + bitTime >> 1                              ' sync + 1/2 bit  
   repeat 8
     waitcnt(t += bitTime)                              ' wait for middle of bit
     rxByte := ina[sin] << 7 | rxByte >> 1              ' sample bit      
   waitcnt(t+bitTime)                                   ' allow for stop bit  
   rxByte := (rxByte ^ inverted) & $FF                  ' adjust for mode and strip off high bits
 
PUB calculate
   Startbyte := Buffer [0]                            
   PinState  := Buffer [1]                            
   cwvL      := Buffer [2]                             
   cwvH      := Buffer [3]                             
   cwwL      := Buffer [4]
   cwwH      := Buffer [5]
   cwxL      := Buffer [6]
   cwxH      := Buffer [7]
   cwyL      := Buffer [8]
   cwyH      := Buffer [9]
   cwyL      := Buffer [10]
   cwyH      := Buffer [11]
           
PUB Display_values   | CWV, CWW, CWX, CWY, CWZ
    VGA.out($00)
    VGA.str(string("Result of ct515:",$0D))
    VGA.str(string($0D,"Startbyte : "))
    VGA.hex(Startbyte,2)
    VGA.str(string($0D,"Pinstate  : "))
    VGA.bin(Pinstate,6 )
    VGA.str(string($0D,"CWV       : ")) 
    CWV := cwvL + (cwvH * 256)
    VGA.dec(CWV)
    VGA.str(string($0D,"CWW       : ")) 
    CWV := cwwL + (cwwH * 256)
    VGA.dec(CWW)
    VGA.str(string($0D,"CWX       : ")) 
    CWV := cwxL + (cwxH * 256)
    VGA.dec(CWX)
    VGA.str(string($0D,"CWY       : ")) 
    CWV := cwyL + (cwyH * 256)
    VGA.dec(CWY)
    VGA.str(string($0D,"CWZ       : ")) 
    CWV := cwzL + (cwzH * 256)
    VGA.dec(CWZ)
    
 